﻿#include <hmg.ch>

#define aFExtensions { "*.txt", "*.prg", "*.fmg" }
#define CRLF2 CRLF + CRLF
#define UTF8_FBOM       CHR( 0xEF ) + CHR( 0xBB ) + CHR( 0xBF )  // UT8 File Byte Order Mark ( File Signature )
#define cCurCodePage    HB_CdPOS()
#define c1Tab CHR( 9 )
#define nTrim( n )  LTRIM( TRAN( n, "999,999,999,999" ) )

PROCEDURE Main()

   SET DATE GERM
   SET CENT ON
   SET( _SET_EOF, .F. )

   DEFINE WINDOW  frmMain ; 
      AT 0, 0 ;
      WIDTH  670 ;
      HEIGHT 450 ;
      TITLE "Convert ANSI plain text file to UTF-8";
      MAIN
      
      ON KEY ESCAPE OF frmMain ACTION ThisWindow.Release
      
      DEFINE MAINMENU
      
         DEFINE POPUP "File"
            DEFINE POPUP "Select"   
               ITEM "File(s)" NAME mitSelFile ACTION SelSrcs()
               ITEM "Folder"  NAME mitSelFold ACTION SelSrcs()
            END POPUP   
         END POPUP
         
         DEFINE POPUP "Info"
            ITEM "Read me"    ACTION ShowReadMe()            
            ITEM "Code Pages" ACTION ;
                  MsgInfo( "HMG_Version() : "    + c1Tab + HMGVersion()     + CRLF +; 
                           "HB_CdPOS() : "       + c1Tab + HB_CdPOS()       + CRLF +; 
                           "HB_CdPTerm() : "     + c1Tab + HB_CdPTerm()     + CRLF +; 
                           "HB_CdPSelect() : "   + c1Tab + HB_CdPselect()   + CRLF +; 
                           "HB_SetCodePage() : " + c1Tab + HB_SetCodePage(), "Current Code Pages" )         
                           

            ITEM "About" ACTION MsgInfo( "ANSI plain text file to UTF-8 Conversion" + CRLF2 + ;
                                         "Author : Esgici" + CRLF2 +;
                                         "Enhanced by : Serge Girard", "Program Info" )
         END POPUP         
      END MENU // MAIN
      
      DEFINE IMAGE imgBackGr
         ROW 0
         COL 0
         WIDTH   657
         HEIGHT  352 
         PICTURE "UTF8.JPG"
      END IMAGE
      
      DEFINE STATUSBAR OF frmMain FONT 'Verdana' SIZE 8
         STATUSITEM ""
         DATE WIDTH 80
         CLOCK WIDTH 90
      END STATUSBAR
      
   END WINDOW // frmMain  
   
   CENTER WINDOW frmMain
   ACTIVATE WINDOW frmMain
   
RETURN // ANSI2UT8.Main()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

PROCEDURE ShowReadMe()
   EXECUTE FILE "NOTEPAD.EXE" PARAMETERS "CFANS2UT8_ReadMe.txt"
RETURN // ShowReadMe()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._
   
PROCEDURE SelSrcs()

   LOCAL lFolder := RIGHT( This.Name, 1 ) = "d"
   
   LOCAL cWorkFolder,;
         a1FList,;         
         c1FSpec,;
         aSrcFiles := {},;
         nFilCount 
  
   IF lFolder
      cWorkFolder := GetFolder( "Select Folder", GetCurrentFolder() )
      IF !EMPTY( cWorkFolder )
         SetCurrentFolder( cWorkFolder )
         FOR EACH c1FSpec IN aFExtensions
            a1FList := DIRECTORY( c1FSpec )
            AEVAL( a1FList, { | a1 | AADD( aSrcFiles, a1[ 1 ] ) } )
         NEXT c1FSpec
      ENDIF !EMPTY( cWorkFolder )
   ELSE
      aSrcFiles := GetFile( { { "Program Source Files",  "*.PRG" },; 
                              { "Form definition files", "*.FMG" },;
                              { "Text Files",            "*.TXT" } },; 
                              "Select File(s) to processing",; 
                              GetCurrentFolder(),;     // cDefaultPath
                              .T.,;  // lMultiSelect
                              .T. ) // lNoChangeDir
                              
      IF ! EMPTY( aSrcFiles )
         cWorkFolder := LEFT( aSrcFiles[ 1 ], RAT( "\", aSrcFiles[ 1 ] ) )
         AEVAL( aSrcFiles, { | c1, i1 | aSrcFiles[ i1 ] := SUBSTR( c1, RAT( "\", c1 ) + 1 ) } )
      ENDIF ! EMPTY( aSrcFiles )
      
   ENDIF
   
   IF !EMPTY( cWorkFolder )
      SetCurrentFolder( cWorkFolder )
   
      nFilCount := LEN( aSrcFiles )

      IF nFilCount > 0
         IF MsgYesNo( NTOC( LEN( aSrcFiles ) ) + ' file' + IF( nFilCount > 1, 's ', ' ' ) + ;
                            IF( lFolder, 'found', 'selected' ) + ";" + CRLF2 + ;
                            'Proceed ?', 'Confirm process' )     
          CAF2UT8( aSrcFiles )            
         ENDIF
      ELSE
         MsgSTop( "Defined file types not found in selected folder" + CRLF2 +;
                  "( " + cWorkFolder + " )", "Not found file to proceed" )
      ENDIF nFilCount > 0
      
   ENDIF !EMPTY( cWorkFolder )
   
RETURN // SelSrcs()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

PROCEDURE CAF2UT8(;
                  aSrcFiles )      

   LOCAL cTmpFNam,;
         cSrcFNam,; 
         cSrcFHnd,; 
         cTrgFNam,;
         c1Line,;
         nFSizeBef,;
         nFSizeAft,;
         nLineCo
         
   OpenAlte()
   
   ? "Folder :", GetCurrentFolder()
   ?
   
   FOR EACH cSrcFNam IN aSrcFiles
   
      
      nFSizeBef := FILESIZE( cSrcFNam )
        
      frmMain.StatusBar.Item( 1 ) := cSrcFNam
      
      ? cSrcFNam
      
      IF FileStr( cSrcFNam , 3 ) # UTF8_FBOM
      
         cTmpFNam := TEMPFILE( GetCurrentFolder(),'tmp' )
         
         cSrcFHnd := HB_FUse( cSrcFNam )
         
         StrFile( UTF8_FBOM, cTmpFNam, .T. )
         
         nLineCo := 0
         
         WHILE .NOT. HB_FEof()
            c1Line := HB_FReadLN()
            ++nLineCo 
            StrFile( HB_STRTOUTF8( c1Line, cCurCodePage ) + CRLF, cTmpFNam, .T. )
            HB_FSkip(1)
            frmMain.StatusBar.Item( 1 ) := c1Line
            DO EVENTS
         ENDDO
         
         HB_FUse()
         
         IF DELETEFILE( cSrcFNam ) < 0
            MsgStop( "Couldn't DELETE file " + cSrcFNam, "ERROR !" )
            ?? "Couldn't DELETE file "
         ELSE
            IF RENAMEFILE( cTmpFNam, cSrcFNam ) < 0
               MsgStop( "Couldn't RENAME file " + cSrcFNam, "ERROR !" ) 
               ?? "Couldn't RENAME file "
            ELSE  
               nFSizeAft := FILESIZE( cSrcFNam )         
               ?? " :", nTrim( nLineCo ), "lines, ", nTrim( nFSizeBef ), "bytes converted to UT8 format in", nTrim( nFSizeAft ), " bytes."
            ENDIF RENAMEFILE( cTmpFNam, cSrcFNam ) < 0            
         ENDIF DELETEFILE( cSrcFNam ) < 0
      ELSE
         ?? " file is UT8 format; skipped."
      ENDIF IsUT8File( cSrcFNam )
      
   NEXT cSrcFNam 
   
   frmMain.StatusBar.Item( 1 ) := ''
   
   ClosAlte()
   
RETURN // CAF2UT8()            

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

